# Redmine - project management software
# Copyright (C) 2006-2013  Jean-Philippe Lang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

class JournalDetail < ActiveRecord::Base
  include UserScoreHelper
  belongs_to :journal
  before_save :normalize_values
  after_save :be_user_score
  after_destroy :down_user_score
  #before_destroy :down_user_score
  private

  def normalize_values
    self.value = normalize(value)
    self.old_value = normalize(old_value)
  end

  def normalize(v)
    case v
    when true
      "1"
    when false
      "0"
    when Date
      v.strftime("%Y-%m-%d")
    else
      v
    end
  end

  def be_user_score
    #更新缺陷完成度
    if self.prop_key == 'done_ratio'
      update_issue_done_ratio(self.journal.user,1)
      unless self.journal.project.nil?
        update_issue_done_ratio(self.journal.user,2,self.journal.project)
      end
    #更新缺陷状态
    elsif self.prop_key == 'status_id'
      update_issues_status(self.journal.user , 1)
      unless self.journal.project.nil?
        update_issues_status(self.journal.user,2,self.journal.project)
      end
    end
  end

  #更新用户分数
  def down_user_score

    if self.prop_key == 'done_ratio'
      update_issue_done_ratio(self.journal.user,1)
      unless self.journal.project.nil?
        update_issue_done_ratio(self.journal.user,2,self.journal.project)
      end

      #更新缺陷状态
    elsif self.prop_key == 'status_id'
      update_issues_status(self.journal.user, 1)
      unless self.journal.project.nil?
        update_issues_status(self.journal.user,2,self.journal.project)
      end
    end
  end

end
